'    Copyright 2007, Leonardo Cecchi
'
'    This file is part of Project Manager.
'
'    Project Manager is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    Project Manager is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Project Manager; if not, write to the Free Software
'    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include once "BE_LineFile.bi"

#ifdef __FB_LANG__
  #if __FB_LANG__ <> "fb"
    Option Byval
	Option Explicit
  #endif
#else
    Option Byval
	Option Explicit
#endif

const as String TOD_O_MARK="TODO"

const as Integer MAX_FILES=100
const as Integer MAX_OUTPUT_ROWS=100
const as String CONF_FILE_NAME="project.cfg"

const as String EDITOR_KEY="editor"
const as String EDITOR_GOTO_KEY="editorGoto"
const as String COMPILER_KEY="compiler"
const as String DEBUGGER_KEY="debugger"
const as String PDFLATEX_KEY="pdflatex"
const as String PDF_KEY="pdf"
const as String BASIC_MAIN_KEY="basicMain"
const as String LATEX_MAIN_KEY="latexMain"
const as String TEMPORARY_FILE_KEY="tempFile"
const as String EXEC_COMMAND_KEY="execCmd"

const as String DEF_EDITOR="scite <file>"
const as String DEF_EDITOR_GOTO="scite <file> -goto:<row>"
const as String DEF_COMPILER="fbc"
const as String DEF_DEBUGGER="ddd"
const as String DEF_PDFLATEX="pdflatex"
const as String DEF_PDF="xpdf"
const as String DEF_BASIC_MAIN="Main.bas"
const as String DEF_LATEX_MAIN="documentation.tex"
#ifdef __FB_LINUX__
const as String DEF_TEMPORARY_FILE="/tmp/tempfile.log"
const as String DEF_EXEC_COMMAND="xterm -e <cmd>"
#else
const as String DEF_TEMPORARY_FILE="c:\tempfile.log"
const as String DEF_EXEC_COMMAND="<cmd>"
#endif

type Project
	sourceFiles(1 to MAX_FILES) as String 
	includeFiles(1 to MAX_FILES) as String
	docFiles(1 to MAX_FILES) as String
	docFilesTex(1 to MAX_FILES) as String
	sourceFilesCount as Integer
	includeFilesCount as Integer
	docFilesCount as Integer
	docFilesTexCount as Integer
	projectDirectory as String
	separator as String
	
	configuration as LineFile	

	outputRows(1 to MAX_OUTPUT_ROWS) as String
	outputRowsCount as Integer	
end type

declare sub P_Init(self as Project ptr)
declare sub P_Init_From_Dir(self as Project ptr, directory as String)
declare sub P_Close(self as Project ptr)
declare function P_Empty(self as Project ptr) as integer
declare sub P_Refresh(self as Project ptr)
declare sub P_Write_Conf(self as Project ptr)
declare sub P_Compile(self as Project ptr)
declare sub P_Execute(self as Project ptr)
declare sub P_Debug(self as Project ptr)
declare sub P_Todo_Grepper(self as Project ptr)
declare sub P_Grep_All_Files(self as Project ptr, mark as String)
