'    Copyright 2007, Leonardo Cecchi
'
'    This file is part of Project Manager.
'
'    Project Manager is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    Project Manager is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Project Manager; if not, write to the Free Software
'    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include "gtk/gtk.bi"
#include "BE_Utils.bi"

'-----------------------------------------
' Rimpiazza per sottostringhe
'-----------------------------------------
Function str_replace(search As String, replace As String, Byval text As String) As String
     If search=replace Then Return text
     Dim text2 As String, posi As Integer = 1, posi2 As Integer
     While Instr(posi,text,search)
         text2=Left(text,Instr(posi,text,search)-1)
         text2+=replace
         posi2=Len(text2)+1
         text2+=Mid(text,Instr(posi,text,search)+Len(search))
         text=text2
         posi=posi2
     Wend
     Return text
 End Function

'-----------------------------------------
' Ritorna true se il file esiste
'-----------------------------------------
function FileExists(fileName as String) as Integer
	Dim f As Integer

	f = Freefile

	If( Open( filename, For Input, As #f ) = 0 ) Then
		Function = -1
	Close #f
	Else
		Function = 0
	End If
end function

'-----------------------------------------
' Crea un file non esistente
'-----------------------------------------
sub CreateEmptyFile(fileName as String)
	dim as Integer fileNo
	
	if not FileExists(fileName) then
		fileNo=FreeFile()
		open fileName for output as #fileNo
		print #fileNo, ""
		close #fileNo
	end if
end sub

' ----------------------------------------------------
' Information Dialog
' ----------------------------------------------------
sub InformationDialog(message as String)
	dim as GtkWidget ptr dialog
	dialog=gtk_message_dialog_new(0, GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_OK, message)
	gtk_dialog_run(GTK_DIALOG(dialog))
	gtk_widget_destroy(dialog)
end sub

' ----------------------------------------------------
' Yes/No Dialog
' ----------------------------------------------------
function YesNoDialog(message as String) as Integer
	dim as GtkWidget ptr dialog
	dim as Integer s
	dialog=gtk_message_dialog_new(0, GTK_DIALOG_MODAL, GTK_MESSAGE_INFO, GTK_BUTTONS_YES_NO, message)
	s=gtk_dialog_run(GTK_DIALOG(dialog))
	gtk_widget_destroy(dialog)
	
	return s=GTK_RESPONSE_YES
end function

' ----------------------------------------------------
' Divide un nome in modo da separare il prefisso
' dal suffisso
' ----------------------------------------------------
sub SplitFileName(fileName as String, byref prefix as String, byref modName as String)
	dim as Integer i, lastUnderscore
	
	for i=len(fileName) to 1 step -1
		if mid(fileName,i,1)="_" then
			exit for
		end if
	next
	
	if i=0 then
		' Nessun prefisso
		prefix=""
		modName=fileName
		return
	else
		lastUnderscore=i
	end if
	
	modName=mid(fileName, i+1)
	prefix=left(fileName, i-1)
end sub

