'    Copyright 2007, Leonardo Cecchi
'
'    This file is part of Project Manager.
'
'    Project Manager is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    Project Manager is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Project Manager; if not, write to the Free Software
'    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include once "PM_Frame.bi"
#include once "PM_InputDialog.bi"
#include once "PM_SearchDialog.bi"
#include once "BE_Utils.bi"
#include once "ProjectManager.bi"

#define NULL 0

' ----------------------------------------------------
' Click sulla lista
' ----------------------------------------------------
sub PMF_ButtonPress cdecl (byval widget as GtkWidget ptr, byval event as GtkTreePath ptr, byval column as GtkTreeViewColumn ptr, Self as PM_Frame ptr)
	dim as GtkTreeSelection ptr selection
	dim as GtkTreeModel ptr model
	dim as GtkTreeIter iter
	dim selezionato as String = ""

	selection=gtk_tree_view_get_selection(GTK_TREE_VIEW(widget))
	if gtk_tree_selection_get_selected(selection, @model, @iter) then
		dim p as zstring ptr
		gtk_tree_model_get(model, @iter, COL_FILE_NAME, @p, -1)
		selezionato=selezionato+(*p)
		g_free(p)
	else
		print "Nessuna riga???"
	end if
	
	if len(selezionato)<>0 then
		dim comando as String
		dim editor as String
		editor=LF_Get(@self->progetto.configuration, EDITOR_KEY)
		editor=str_replace(FILE_INDICATOR, selezionato, editor)
		comando=editor+" "
		shell(comando)
	end if
end sub

' ----------------------------------------------------
' Click sulla lista
' ----------------------------------------------------
sub PMF_ButtonPress_Log cdecl (byval widget as GtkWidget ptr, byval event as GtkTreePath ptr, byval column as GtkTreeViewColumn ptr, Self as PM_Frame ptr)
	dim as GtkTreeSelection ptr selection
	dim as GtkTreeModel ptr model
	dim as GtkTreeIter iter
	dim selezionato as String = ""
	
	selection=gtk_tree_view_get_selection(GTK_TREE_VIEW(widget))
	if gtk_tree_selection_get_selected(selection, @model, @iter) then
		dim p as zstring ptr
		gtk_tree_model_get(model, @iter, COL_FILE_NAME, @p, -1)
		selezionato=selezionato+(*p)
		g_free(p)
	else
		print "Nessuna riga???"
	end if
	
	if len(selezionato)<>0 then
		dim as String fileName="", rowNumber="", c=""
		dim as Integer fase=0, i
		for i=1 to len(selezionato)
			c=mid(selezionato,i,1)
			if c="(" then
				fase=1
			elseif c=")" then
				exit for
			elseif fase=0 then
				fileName=fileName+c
			elseif fase=1 then
				rowNumber=rowNumber+c
			end if
		next
		
		if FileExists(filename)<>0 then
			dim comando as String
			dim editor as String
			editor=LF_Get(@self->progetto.configuration, EDITOR_GOTO_KEY)
			editor=str_replace(ROW_INDICATOR, rowNumber, editor)
			editor=str_replace(FILE_INDICATOR, fileName, editor)
			comando=editor+" & "
			shell(comando)
		end if  		
	end if
end sub

' ----------------------------------------------------
' Inserimento di una lista di files in uno store
' ad albero in base al prefissi dei nomi dei files
' ----------------------------------------------------
sub PMF_Insert_In_Store(store as GtkTreeStore ptr, _
	list() as String, count as Integer, tipo as String)

	dim as GtkTreeIter iter, iterPrefix
	dim as String currentPrefix
	dim as String modName, prefix
	dim as Integer i
	
	' Inserimento dei files 
	currentPrefix=""
	for i=1 to count
		SplitFileName(list(i), prefix, modName)		
		
		if currentPrefix<>prefix and len(prefix)<>0 then		
			currentPrefix=prefix
			gtk_tree_store_append(store, @iterPrefix, NULL)
			gtk_tree_store_set(store, @iterPrefix, COL_FILE_NAME, _ 
				currentPrefix, COL_TYPE, T_("Section"), -1)
			gtk_tree_store_append(store, @iter, @iterPrefix)
		elseif len(prefix)=0 then		
			gtk_tree_store_append(store, @iter, NULL)
		else
			gtk_tree_store_append(store, @iter, @iterPrefix)
		end if
		
		gtk_tree_store_set(store, @iter, _
			COL_FILE_NAME, list(i), _
			COL_TYPE, tipo, -1)
	next
end sub	

' ----------------------------------------------------
' Inserimento di una lista di files in uno store
' a lista in base al prefissi dei nomi dei files
' ----------------------------------------------------
sub PMF_Insert_In_List_Store(store as GtkListStore ptr, _
	list() as String, count as Integer, tipo as String)

	dim as GtkTreeIter iter, iterPrefix
	dim as Integer i
	
	' Inserimento dei files 
	for i=1 to count
		gtk_list_store_append(store, @iter)
		gtk_list_store_set(store, @iter, _
			COL_FILE_NAME, list(i), _
			COL_TYPE, tipo, -1)
	next
end sub	


' ----------------------------------------------------
' Creazione della lista dei file a partire da una 
' directory
' ----------------------------------------------------
sub PMF_Refresh_List (Self as PM_Frame ptr)	
	gtk_tree_store_clear(self->storeSources)
	gtk_tree_store_clear(self->storeIncludes)
	gtk_list_store_clear(self->storeDocs)
	gtk_list_store_clear(self->storeCompilerMessages)

	PMF_Insert_In_Store(self->storeSources, self->progetto.sourceFiles(), _
		self->progetto.sourceFilesCount, T_("Source"))

	PMF_Insert_In_Store(self->storeIncludes, self->progetto.includeFiles(), _
		self->progetto.includeFilesCount, T_("Include"))
	
	PMF_Insert_In_List_Store(self->storeDocs, self->progetto.docFilesTex(), _
		self->progetto.docFilesTexCount, T_("TEX File"))

	PMF_Insert_In_List_Store(self->storeDocs, self->progetto.docFiles(), _
		self->progetto.docFilesCount, T_("Text File"))
end sub

' ----------------------------------------------------
' Refresh di un progetto
' ----------------------------------------------------
sub PMF_Refresh_Project cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
	if not P_Empty(@self->progetto) then
		P_Refresh(@self->progetto)
		PMF_Refresh_List(self)
	else
		InformationDialog(T_("Please choose a project"))
	end if
end sub

' ----------------------------------------------------
' Chiusura della finestra
' ----------------------------------------------------
sub PMF_Close cdecl (byref widget as GtkWidget ptr, user_data as gpointer)
	gtk_main_quit()
end sub

' ----------------------------------------------------
' Apertura di un progetto
' ----------------------------------------------------
sub PMF_Open_Project cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
	dim as GtkWidget ptr dialog
	
	dialog=gtk_file_chooser_dialog_new(T_("Choose the Project Directory"), _
		GTK_WINDOW(self->frame), GTK_FILE_CHOOSER_ACTION_SELECT_FOLDER, _
		GTK_STOCK_CANCEL, GTK_RESPONSE_CANCEL, GTK_STOCK_OPEN, GTK_RESPONSE_ACCEPT, 0)
	if gtk_dialog_run(GTK_DIALOG(dialog)) =	 GTK_RESPONSE_ACCEPT then
		dim p as zstring ptr
		p=gtk_file_chooser_get_filename(GTK_FILE_CHOOSER(dialog))
		P_Close(@self->progetto)
		P_Init_From_Dir(@self->progetto, ""+(*p))
		g_free(p)
		PMF_Refresh_List(self)
	end if
	gtk_widget_destroy(dialog)
end sub

' ----------------------------------------------------
' Configurazione di un progetto
' ----------------------------------------------------
sub PMF_Configure_Project cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
	if not P_Empty(@self->progetto) then
		dim p as PM_Configuration 
		PM_Configuration_Init(@p, Self->frame)
		PM_Configuration_Read(@p, @self->progetto.configuration)
		if PM_Configuration_Run(@p)=GTK_RESPONSE_ACCEPT then
			PM_Configuration_Update(@p, @self->progetto.configuration)
			P_Write_Conf(@self->progetto)
		end if
		PM_Configuration_Destroy(@p)
	else
		InformationDialog(T_("Please choose a project"))
	end if
end sub

' ----------------------------------------------------
' Chiusura di un progetto
' ----------------------------------------------------
sub PMF_Close_Project cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
	gtk_tree_store_clear(self->storeSources)
	gtk_tree_store_clear(self->storeIncludes)
	gtk_list_store_clear(self->storeDocs)
	gtk_list_store_clear(self->storeCompilerMessages)
	P_Close(@self->progetto)
end sub

' ----------------------------------------------------
' Ricarica l'output della frame dal progetto
' ----------------------------------------------------
sub PMF_RefreshOutputFromProject(self as PM_Frame ptr)
	dim as GtkTreeIter iter
	dim as Integer i

	gtk_list_store_clear(self->storeCompilerMessages)
	for i=1 to self->progetto.outputRowsCount
		gtk_list_store_append(self->storeCompilerMessages, @iter)
		gtk_list_store_set(self->storeCompilerMessages, @iter, _
			COL_LOG, self->progetto.outputRows(i), _
			COL_TYPE, T_("TEX File"), -1)
	next	
	
	if self->progetto.outputRowsCount=0 then
		gtk_list_store_append(self->storeCompilerMessages, @iter)
		gtk_list_store_set(self->storeCompilerMessages, @iter, _
			COL_LOG, T_("All OK :-)"), _
			COL_TYPE, T_("TEX File"), -1)
	end if
end sub

' ----------------------------------------------------
' Compilazione di un progetto
' ----------------------------------------------------
sub PMF_Build cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
	if not P_Empty(@self->progetto) then
		P_Compile(@self->progetto)
		PMF_RefreshOutputFromProject(self)
		gtk_notebook_set_current_page(GTK_NOTEBOOK(self->notebook), 3)
	else
		InformationDialog(T_("Please choose a project"))
	end if
end sub

' ----------------------------------------------------
' Run di un progetto
' ----------------------------------------------------
sub PMF_Run cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
	if not P_Empty(@self->progetto) then
		P_Execute(@self->progetto)
		PMF_RefreshOutputFromProject(self)
		gtk_notebook_set_current_page(GTK_NOTEBOOK(self->notebook), 3)
	else
		InformationDialog(T_("Please choose a project"))
	end if
end sub

' ----------------------------------------------------
' Debug di un progetto
' ----------------------------------------------------
sub PMF_Debug cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
	if not P_Empty(@self->progetto) then
		P_Debug(@self->progetto)
		PMF_RefreshOutputFromProject(self)
		gtk_notebook_set_current_page(GTK_NOTEBOOK(self->notebook), 3)
	else
		InformationDialog(T_("Please choose a project"))
	end if
end sub

' ----------------------------------------------------
' About Dialog
' ----------------------------------------------------
sub PMF_About cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
	dim as GtkWidget ptr dialog
	dim as Zstring ptr ptr authors
	
	authors=allocate(sizeof(zstring ptr)*2)
	authors[0]=@PROJMAN_AUTHOR
	authors[1]=0
	
	
	dialog=gtk_about_dialog_new()
	gtk_about_dialog_set_name(GTK_ABOUT_DIALOG(dialog), PROJMAN_NAME)
	gtk_about_dialog_set_version(GTK_ABOUT_DIALOG(dialog), PROJMAN_VER)
	gtk_about_dialog_set_comments(GTK_ABOUT_DIALOG(dialog), PROJMAN_COMMENTS)
	gtk_about_dialog_set_authors(GTK_ABOUT_DIALOG(dialog), authors)
	gtk_about_dialog_set_website(GTK_ABOUT_DIALOG(dialog), PROJMAN_WEB)
	gtk_dialog_run(GTK_DIALOG(dialog))
	gtk_window_set_modal(GTK_WINDOW(dialog), -1)
	gtk_window_set_transient_for(GTK_WINDOW(dialog), GTK_WINDOW(self->frame))
	gtk_widget_destroy(dialog)
	
	deallocate(authors)
end sub
