'    Copyright 2007, Leonardo Cecchi
'
'    This file is part of Project Manager.
'
'    Project Manager is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    Project Manager is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Project Manager; if not, write to the Free Software
'    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include once "gtk/gtk.bi"
#include once "dir.bi"
#include once "Translations.bi"
#include once "BE_Project.bi"
#include once "PM_Configuration.bi"

#ifdef __FB_LANG__
  #if __FB_LANG__ <> "fb"
    Option Byval
	Option Explicit
  #endif
#else
    Option Byval
	Option Explicit
#endif

const as String ROW_INDICATOR="<row>"
const as String FILE_INDICATOR="<file>"

const COL_FILE_NAME=0
const COL_TYPE=1

const COL_LOG=0

type PM_Frame
	titolo as String
	progetto as Project
	frame as GtkWidget ptr
	vbox as GtkWidget ptr
	notebook as GtkWidget ptr
	
	tvSources as GtkWidget ptr
	tvIncludes as GtkWidget ptr
	tvDocs as GtkWidget ptr
	tvCompilerMessages as GtkWidget ptr
	
	storeSources as GtkTreeStore ptr
	storeIncludes as GtkTreeStore ptr
	storeDocs as GtkListStore ptr
	storeCompilerMessages as GtkListStore ptr
end type

declare sub PMF_Refresh_List (Self as PM_Frame ptr)	
declare sub PMF_Close cdecl (byref widget as GtkWidget ptr, user_data as gpointer)
declare sub PMF_Open_Project cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_Close_Project cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_Refresh_Project cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_RefreshOutputFromProject(self as PM_Frame ptr)
declare sub PMF_Configure_Project cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_Todo cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_FileSearch cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_Build cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_Run cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_Debug cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_ButtonPress cdecl (byval widget as GtkWidget ptr, byval event as GtkTreePath ptr, byval column as GtkTreeViewColumn ptr, Self as PM_Frame ptr)
declare sub PMF_ButtonPress_Log cdecl (byval widget as GtkWidget ptr, byval event as GtkTreePath ptr, byval column as GtkTreeViewColumn ptr, Self as PM_Frame ptr)
declare sub PMF_NewFile cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_About cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_DeleteFile cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_RenameFile cdecl (byref widget as GtkWidget ptr, self as PM_Frame ptr)
declare sub PMF_MenuBar(Self as PM_Frame ptr)
declare sub PMF_Tree_Init(self as PM_Frame ptr)
declare sub PMF_Toolbar_Init(self as PM_Frame ptr)
declare sub PMF_Init(Self as PM_Frame ptr)
