'    Copyright 2007, Leonardo Cecchi
'
'    This file is part of Project Manager.
'
'    Project Manager is free software; you can redistribute it and/or modify
'    it under the terms of the GNU General Public License as published by
'    the Free Software Foundation; either version 2 of the License, or
'    (at your option) any later version.
'
'    Project Manager is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU General Public License for more details.
'
'    You should have received a copy of the GNU General Public License
'    along with Project Manager; if not, write to the Free Software
'    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

#include once "PM_InputDialog.bi"

'---------------------------------
' Run this input dialog
'---------------------------------
sub ID_Init(self as InputDialog ptr, parent as GtkWidget ptr, description as String, message as String = "")
	dim as GtkWidget ptr label, hbox, labelMessage
	
	self->text=""
	
	self->dialog=gtk_dialog_new_with_buttons(T_("Search in Files"), _
		GTK_WINDOW(parent), _
		GTK_DIALOG_MODAL or GTK_DIALOG_DESTROY_WITH_PARENT, _
		GTK_STOCK_OK, GTK_RESPONSE_ACCEPT, _
		GTK_STOCK_CANCEL, GTK_RESPONSE_REJECT, 0)

	self->entry=gtk_entry_new()
	label=gtk_label_new(description)
	
	hbox=gtk_hbox_new(0, 2)
	gtk_box_pack_start(GTK_BOX(hbox), label, 0, 0, 1)
	gtk_box_pack_start(GTK_BOX(hbox), self->entry, 0, 0, 1)

	if len(message)<>0 then
		labelMessage=gtk_label_new(message)
		gtk_box_pack_start(GTK_BOX(GTK_DIALOG(self->dialog)->vbox), labelMessage, 0, 0, 1)
	end if

	gtk_box_pack_start(GTK_BOX(GTK_DIALOG(self->dialog)->vbox), hbox, 0, 0, 1)
	gtk_widget_show_all(GTK_DIALOG(self->dialog)->vbox)
end sub

'---------------------------------
' Run this input dialog
'---------------------------------
function ID_Run(Self as InputDialog ptr) as Integer
	dim v as Integer
	v=gtk_dialog_run(GTK_DIALOG(self->dialog))
	self->text=""+(*gtk_entry_get_text(GTK_ENTRY(self->entry)))
	self->text=trim(self->text)
	return v
end function

'---------------------------------
' Destroy this input dialog
'---------------------------------
sub ID_Destroy(Self as InputDialog ptr)
	gtk_widget_destroy(self->dialog)
end sub

'---------------------------------
' Default settings for this input
' dialog
'---------------------------------
sub ID_SetDefault(self as InputDialog ptr, def as String)
	gtk_entry_set_text(GTK_ENTRY(self->entry), def)
end sub
